#!/usr/bin/env python
#
# Youcope Emulator
#
#(c)2007 Felipe Sanches
#(c)2007 Leandro Lameiro
#licensed under GNU GPL v3 or later

import wave
import struct
import sys
import math
import random
import pygame
from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

SIZE = (640,480)
FPS = 48

wro = wave.open('youscope-wave.wav')
READ_LENGTH = wro.getframerate()/FPS

glutInit([])
glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE)
glutInitWindowSize (SIZE[0],SIZE[1]);
glutCreateWindow('YouScope XY-Demo Osciloscope Emulator GL Editionz0r')
clock = pygame.time.Clock()
f = 0

def _idle():
    global clock, FPS
    clock.tick(FPS)
    glutPostRedisplay()
    
def _display():
    global SIZE, wro, READ_LENGTH
    glViewport(0,0,SIZE[0],SIZE[1])
    glClearColor(0,0,0,0)
    glEnable(GL_BLEND)
    glEnable(GL_POINT_SMOOTH)
    glEnable(GL_LINE_SMOOTH)
    glBlendFunc(GL_SRC_ALPHA, GL_ONE)
    frames = wro.readframes(READ_LENGTH)

    glClear(GL_COLOR_BUFFER_BIT)

    glPointSize(5)
    glColor(0.5,1,0.5,1)
    glBegin(GL_POINTS)
    for i in range(0,READ_LENGTH,4):
        r = struct.unpack('hh', frames[i:i+4])
        x = r[1]/32768.0 
        y = r[0]/32768.0
        glVertex(x,y)
    glEnd()



    glColor(0.2,1,0.2,0.025)
    glLineWidth(3)
    glBegin(GL_LINES)
    ticks = pygame.time.get_ticks()/1000.0
    lx = math.pow(math.sin(ticks/6.1),13)*0.8+math.pow(math.cos(ticks/4.1),13)*0.2
    ly = math.pow(math.cos(ticks/2.0),13)*0.8+math.pow(math.sin(ticks/8.2),13)*0.2
    ld = 100
    eps = 0.001
    for i in range(0,READ_LENGTH/2,4):
        r = struct.unpack('hh', frames[i:i+4])
        x = r[1]/32768.0 
        y = r[0]/32768.0
        if x>-1+eps and y>-1+eps and x<1-eps and y<1-eps:
            glVertex(lx,ly)
            glVertex(ld*(x-lx),ld*(y-ly))
    glEnd()
    lx = math.pow(math.sin(ticks/3.1),13)*0.8+math.pow(math.cos(ticks/8.1),13)*0.2
    ly = math.pow(math.cos(ticks/4.0),13)*0.8+math.pow(math.sin(ticks/2.2),13)*0.2
    ld = 100
    eps = 0.001
    glBegin(GL_LINES)
    for i in range(READ_LENGTH/2,READ_LENGTH,4):
        r = struct.unpack('hh', frames[i:i+4])
        x = r[1]/32768.0 
        y = r[0]/32768.0
        if x>-1+eps and y>-1+eps and x<1-eps and y<1-eps:
            glVertex(lx,ly)
            glVertex(ld*(x-lx),ld*(y-ly))
    glEnd()

        
    glutSwapBuffers()
    
glutIdleFunc(_idle)
glutDisplayFunc(_display)
glutMainLoop()
